OpenShot Audio Library | OpenShotAudio: juce::CharPointer_UTF8 Class Reference

OpenShot Audio Library | OpenShotAudio 0.4.0

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Static Public Member Functions | List of all members
juce::CharPointer_UTF8 Class Referencefinal

`#include <juce_CharPointer_UTF8.h>`

## Public Types
enum | { byteOrderMark1 = 0xef , byteOrderMark2 = 0xbb , byteOrderMark3 = 0xbf }
using | CharType = char

## Public Member Functions
| CharPointer_UTF8 (const CharType *rawPointer) noexcept
| CharPointer_UTF8 (const CharPointer_UTF8 &other)=default
CharPointer_UTF8 | operator= (CharPointer_UTF8 other) noexcept
CharPointer_UTF8 | operator= (const CharType *text) noexcept
bool | operator== (CharPointer_UTF8 other) const noexcept
bool | operator!= (CharPointer_UTF8 other) const noexcept
bool | operator<= (CharPointer_UTF8 other) const noexcept
bool | operator< (CharPointer_UTF8 other) const noexcept
bool | operator>= (CharPointer_UTF8 other) const noexcept
bool | operator> (CharPointer_UTF8 other) const noexcept
CharType * | getAddress () const noexcept
| operator const CharType * () const noexcept
bool | isEmpty () const noexcept
bool | isNotEmpty () const noexcept
juce_wchar | operator* () const noexcept
CharPointer_UTF8 & | operator++ () noexcept
CharPointer_UTF8 | operator-- () noexcept
juce_wchar | getAndAdvance () noexcept
CharPointer_UTF8 | operator++ (int) noexcept
void | operator+= (int numToSkip) noexcept
void | operator-= (int numToSkip) noexcept
juce_wchar | operator[] (int characterIndex) const noexcept
CharPointer_UTF8 | operator+ (int numToSkip) const noexcept
CharPointer_UTF8 | operator- (int numToSkip) const noexcept
size_t | length () const noexcept
size_t | lengthUpTo (const size_t maxCharsToCount) const noexcept
size_t | lengthUpTo (const CharPointer_UTF8 end) const noexcept
size_t | sizeInBytes () const noexcept
CharPointer_UTF8 | findTerminatingNull () const noexcept
void | write (const juce_wchar charToWrite) noexcept
void | writeNull () const noexcept
template<typename CharPointer >
void | writeAll (const CharPointer src) noexcept
void | writeAll (const CharPointer_UTF8 src) noexcept
template<typename CharPointer >
size_t | writeWithDestByteLimit (const CharPointer src, const size_t maxDestBytes) noexcept
template<typename CharPointer >
void | writeWithCharLimit (const CharPointer src, const int maxChars) noexcept
template<typename CharPointer >
int | compare (const CharPointer other) const noexcept
template<typename CharPointer >
int | compareUpTo (const CharPointer other, const int maxChars) const noexcept
template<typename CharPointer >
int | compareIgnoreCase (const CharPointer other) const noexcept
int | compareIgnoreCase (const CharPointer_UTF8 other) const noexcept
template<typename CharPointer >
int | compareIgnoreCaseUpTo (const CharPointer other, const int maxChars) const noexcept
template<typename CharPointer >
int | indexOf (const CharPointer stringToFind) const noexcept
int | indexOf (const juce_wchar charToFind) const noexcept
int | indexOf (const juce_wchar charToFind, const bool ignoreCase) const noexcept
bool | isWhitespace () const noexcept
bool | isDigit () const noexcept
bool | isLetter () const noexcept
bool | isLetterOrDigit () const noexcept
bool | isUpperCase () const noexcept
bool | isLowerCase () const noexcept
juce_wchar | toUpperCase () const noexcept
juce_wchar | toLowerCase () const noexcept
int | getIntValue32 () const noexcept
int64 | getIntValue64 () const noexcept
double | getDoubleValue () const noexcept
CharPointer_UTF8 | findEndOfWhitespace () const noexcept
void | incrementToEndOfWhitespace () noexcept
CharPointer_UTF8 | atomicSwap (const CharPointer_UTF8 newValue)

## Static Public Member Functions
static size_t | getBytesRequiredFor (const juce_wchar charToWrite) noexcept
template<class CharPointer >
static size_t | getBytesRequiredFor (CharPointer text) noexcept
static bool | canRepresent (juce_wchar character) noexcept
static bool | isValidString (const CharType *dataToTest, int maxBytesToRead)
static bool | isByteOrderMark (const void *possibleByteOrder) noexcept

## Detailed Description

Wraps a pointer to a null-terminated UTF-8 character string, and provides various methods to operate on the data.

See also
  CharPointer_UTF16, CharPointer_UTF32

Definition at line 34 of file juce_CharPointer_UTF8.h.

## Member Typedef Documentation

## ◆ CharType

using juce::CharPointer_UTF8::CharType = char

Definition at line 37 of file juce_CharPointer_UTF8.h.

## Member Enumeration Documentation

## ◆ anonymous enum

anonymous enum

These values are the byte-order mark (BOM) values for a UTF-8 stream.

Definition at line 545 of file juce_CharPointer_UTF8.h.

## Constructor & Destructor Documentation

## ◆ CharPointer_UTF8()

juce::CharPointer_UTF8::CharPointer_UTF8 | ( | const CharType * | rawPointer | ) |
| inlineexplicitnoexcept

Definition at line 39 of file juce_CharPointer_UTF8.h.

## Member Function Documentation

## ◆ atomicSwap()

CharPointer_UTF8 juce::CharPointer_UTF8::atomicSwap | ( | const CharPointer_UTF8 | newValue | ) |
| inline

Atomically swaps this pointer for a new value, returning the previous value.

Definition at line 539 of file juce_CharPointer_UTF8.h.

## ◆ canRepresent()

static bool juce::CharPointer_UTF8::canRepresent | ( | juce_wchar | character | ) |
| inlinestaticnoexcept

Returns true if the given unicode character can be represented in this encoding.

Definition at line 492 of file juce_CharPointer_UTF8.h.

## ◆ compare()

template<typename CharPointer >

int juce::CharPointer_UTF8::compare | ( | const CharPointer | other | ) | const
| inlinenoexcept

Compares this string with another one.

Definition at line 399 of file juce_CharPointer_UTF8.h.

## ◆ compareIgnoreCase() [1/2]

template<typename CharPointer >

int juce::CharPointer_UTF8::compareIgnoreCase | ( | const CharPointer | other | ) | const
| inlinenoexcept

Compares this string with another one.

Definition at line 413 of file juce_CharPointer_UTF8.h.

## ◆ compareIgnoreCase() [2/2]

int juce::CharPointer_UTF8::compareIgnoreCase | ( | const CharPointer_UTF8 | other | ) | const
| inlinenoexcept

Compares this string with another one.

Definition at line 419 of file juce_CharPointer_UTF8.h.

## ◆ compareIgnoreCaseUpTo()

template<typename CharPointer >

int juce::CharPointer_UTF8::compareIgnoreCaseUpTo | ( | const CharPointer | other,
|  | const int | maxChars ) const
| inlinenoexcept

Compares this string with another one, up to a specified number of characters.

Definition at line 426 of file juce_CharPointer_UTF8.h.

## ◆ compareUpTo()

template<typename CharPointer >

int juce::CharPointer_UTF8::compareUpTo | ( | const CharPointer | other,
|  | const int | maxChars ) const
| inlinenoexcept

Compares this string with another one, up to a specified number of characters.

Definition at line 406 of file juce_CharPointer_UTF8.h.

## ◆ findEndOfWhitespace()

CharPointer_UTF8 juce::CharPointer_UTF8::findEndOfWhitespace | ( |  | ) | const
| inlinenoexcept

Returns the first non-whitespace character in the string.

Definition at line 486 of file juce_CharPointer_UTF8.h.

## ◆ findTerminatingNull()

CharPointer_UTF8 juce::CharPointer_UTF8::findTerminatingNull | ( |  | ) | const
| inlinenoexcept

Returns a pointer to the null character that terminates this string.

Definition at line 321 of file juce_CharPointer_UTF8.h.

## ◆ getAddress()

CharType * juce::CharPointer_UTF8::getAddress | ( |  | ) | const
| inlinenoexcept

Returns the address that this pointer is pointing to.

Definition at line 67 of file juce_CharPointer_UTF8.h.

Referenced by juce::StringArray::appendNumbersToDuplicates().

## ◆ getAndAdvance()

juce_wchar juce::CharPointer_UTF8::getAndAdvance | ( |  | ) |
| inlinenoexcept

Returns the character that this pointer is currently pointing to, and then advances the pointer to point to the next character.

Definition at line 147 of file juce_CharPointer_UTF8.h.

## ◆ getBytesRequiredFor() [1/2]

template<class CharPointer >

static size_t juce::CharPointer_UTF8::getBytesRequiredFor | ( | CharPointer | text | ) |
| inlinestaticnoexcept

Returns the number of bytes that would be needed to represent the given string in this encoding format. The value returned does NOT include the terminating null character.

Definition at line 310 of file juce_CharPointer_UTF8.h.

## ◆ getBytesRequiredFor() [2/2]

static size_t juce::CharPointer_UTF8::getBytesRequiredFor | ( | const juce_wchar | charToWrite | ) |
| inlinestaticnoexcept

Returns the number of bytes that would be needed to represent the given unicode character in this encoding format.

Definition at line 286 of file juce_CharPointer_UTF8.h.

Referenced by juce::MemoryOutputStream::appendUTF8Char(), getBytesRequiredFor(), and juce::String::getNumBytesAsUTF8().

## ◆ getDoubleValue()

double juce::CharPointer_UTF8::getDoubleValue | ( |  | ) | const
| inlinenoexcept

Parses this string as a floating point double.

Definition at line 483 of file juce_CharPointer_UTF8.h.

## ◆ getIntValue32()

int juce::CharPointer_UTF8::getIntValue32 | ( |  | ) | const
| inlinenoexcept

Parses this string as a 32-bit integer.

Definition at line 470 of file juce_CharPointer_UTF8.h.

## ◆ getIntValue64()

int64 juce::CharPointer_UTF8::getIntValue64 | ( |  | ) | const
| inlinenoexcept

Parses this string as a 64-bit integer.

Definition at line 473 of file juce_CharPointer_UTF8.h.

## ◆ incrementToEndOfWhitespace()

void juce::CharPointer_UTF8::incrementToEndOfWhitespace | ( |  | ) |
| inlinenoexcept

Move this pointer to the first non-whitespace character in the string.

Definition at line 489 of file juce_CharPointer_UTF8.h.

## ◆ indexOf() [1/3]

template<typename CharPointer >

int juce::CharPointer_UTF8::indexOf | ( | const CharPointer | stringToFind | ) | const
| inlinenoexcept

Returns the character index of a substring, or -1 if it isn't found.

Definition at line 433 of file juce_CharPointer_UTF8.h.

## ◆ indexOf() [2/3]

int juce::CharPointer_UTF8::indexOf | ( | const juce_wchar | charToFind | ) | const
| inlinenoexcept

Returns the character index of a unicode character, or -1 if it isn't found.

Definition at line 439 of file juce_CharPointer_UTF8.h.

## ◆ indexOf() [3/3]

int juce::CharPointer_UTF8::indexOf | ( | const juce_wchar | charToFind,
|  | const bool | ignoreCase ) const
| inlinenoexcept

Returns the character index of a unicode character, or -1 if it isn't found.

Definition at line 445 of file juce_CharPointer_UTF8.h.

## ◆ isByteOrderMark()

static bool juce::CharPointer_UTF8::isByteOrderMark | ( | const void * | possibleByteOrder | ) |
| inlinestaticnoexcept

Returns true if the first three bytes in this pointer are the UTF8 byte-order mark (BOM). The pointer must not be null, and must point to at least 3 valid bytes.

Definition at line 555 of file juce_CharPointer_UTF8.h.

Referenced by juce::String::createStringFromData(), and juce::XmlDocument::getDocumentElement().

## ◆ isDigit()

bool juce::CharPointer_UTF8::isDigit | ( |  | ) | const
| inlinenoexcept

Returns true if the first character of this string is a digit.

Definition at line 454 of file juce_CharPointer_UTF8.h.

## ◆ isEmpty()

bool juce::CharPointer_UTF8::isEmpty | ( |  | ) | const
| inlinenoexcept

Returns true if this pointer is pointing to a null character.

Definition at line 73 of file juce_CharPointer_UTF8.h.

## ◆ isLetter()

bool juce::CharPointer_UTF8::isLetter | ( |  | ) | const
| inlinenoexcept

Returns true if the first character of this string is a letter.

Definition at line 456 of file juce_CharPointer_UTF8.h.

## ◆ isLetterOrDigit()

bool juce::CharPointer_UTF8::isLetterOrDigit | ( |  | ) | const
| inlinenoexcept

Returns true if the first character of this string is a letter or digit.

Definition at line 458 of file juce_CharPointer_UTF8.h.

## ◆ isLowerCase()

bool juce::CharPointer_UTF8::isLowerCase | ( |  | ) | const
| inlinenoexcept

Returns true if the first character of this string is lower-case.

Definition at line 462 of file juce_CharPointer_UTF8.h.

## ◆ isNotEmpty()

bool juce::CharPointer_UTF8::isNotEmpty | ( |  | ) | const
| inlinenoexcept

Returns true if this pointer is not pointing to a null character.

Definition at line 76 of file juce_CharPointer_UTF8.h.

## ◆ isUpperCase()

bool juce::CharPointer_UTF8::isUpperCase | ( |  | ) | const
| inlinenoexcept

Returns true if the first character of this string is upper-case.

Definition at line 460 of file juce_CharPointer_UTF8.h.

## ◆ isValidString()

static bool juce::CharPointer_UTF8::isValidString | ( | const CharType * | dataToTest,
|  | int | maxBytesToRead )
| inlinestatic

Returns true if this data contains a valid string in this encoding.

Definition at line 498 of file juce_CharPointer_UTF8.h.

Referenced by juce::String::createStringFromData(), and juce::String::fromUTF8().

## ◆ isWhitespace()

bool juce::CharPointer_UTF8::isWhitespace | ( |  | ) | const
| inlinenoexcept

Returns true if the first character of this string is whitespace.

Definition at line 452 of file juce_CharPointer_UTF8.h.

## ◆ length()

size_t juce::CharPointer_UTF8::length | ( |  | ) | const
| inlinenoexcept

Returns the number of characters in this string.

Definition at line 237 of file juce_CharPointer_UTF8.h.

## ◆ lengthUpTo() [1/2]

size_t juce::CharPointer_UTF8::lengthUpTo | ( | const CharPointer_UTF8 | end | ) | const
| inlinenoexcept

Returns the number of characters in this string, or up to the given end pointer, whichever is lower.

Definition at line 267 of file juce_CharPointer_UTF8.h.

## ◆ lengthUpTo() [2/2]

size_t juce::CharPointer_UTF8::lengthUpTo | ( | const size_t | maxCharsToCount | ) | const
| inlinenoexcept

Returns the number of characters in this string, or the given value, whichever is lower.

Definition at line 261 of file juce_CharPointer_UTF8.h.

## ◆ operator const CharType *()

juce::CharPointer_UTF8::operator const CharType * | ( |  | ) | const
| inlinenoexcept

Returns the address that this pointer is pointing to.

Definition at line 70 of file juce_CharPointer_UTF8.h.

## ◆ operator!=()

bool juce::CharPointer_UTF8::operator!= | ( | CharPointer_UTF8 | other | ) | const
| inlinenoexcept

Definition at line 60 of file juce_CharPointer_UTF8.h.

## ◆ operator*()

juce_wchar juce::CharPointer_UTF8::operator* | ( |  | ) | const
| inlinenoexcept

Returns the unicode character that this pointer is pointing to.

Definition at line 79 of file juce_CharPointer_UTF8.h.

## ◆ operator+()

CharPointer_UTF8 juce::CharPointer_UTF8::operator+ | ( | int | numToSkip | ) | const
| inlinenoexcept

Returns a pointer which is moved forwards from this one by the specified number of characters.

Definition at line 221 of file juce_CharPointer_UTF8.h.

## ◆ operator++() [1/2]

CharPointer_UTF8 & juce::CharPointer_UTF8::operator++ | ( |  | ) |
| inlinenoexcept

Moves this pointer along to the next character in the string.

Definition at line 115 of file juce_CharPointer_UTF8.h.

## ◆ operator++() [2/2]

CharPointer_UTF8 juce::CharPointer_UTF8::operator++ | ( | int |  | ) |
| inlinenoexcept

Moves this pointer along to the next character in the string.

Definition at line 184 of file juce_CharPointer_UTF8.h.

## ◆ operator+=()

void juce::CharPointer_UTF8::operator+= | ( | int | numToSkip | ) |
| inlinenoexcept

Moves this pointer forwards by the specified number of characters.

Definition at line 192 of file juce_CharPointer_UTF8.h.

Referenced by operator-=().

## ◆ operator-()

CharPointer_UTF8 juce::CharPointer_UTF8::operator- | ( | int | numToSkip | ) | const
| inlinenoexcept

Returns a pointer which is moved backwards from this one by the specified number of characters.

Definition at line 229 of file juce_CharPointer_UTF8.h.

## ◆ operator--()

CharPointer_UTF8 juce::CharPointer_UTF8::operator-- | ( |  | ) |
| inlinenoexcept

Moves this pointer back to the previous character in the string.

Definition at line 135 of file juce_CharPointer_UTF8.h.

## ◆ operator-=()

void juce::CharPointer_UTF8::operator-= | ( | int | numToSkip | ) |
| inlinenoexcept

Moves this pointer backwards by the specified number of characters.

Definition at line 207 of file juce_CharPointer_UTF8.h.

## ◆ operator<()

bool juce::CharPointer_UTF8::operator< | ( | CharPointer_UTF8 | other | ) | const
| inlinenoexcept

Definition at line 62 of file juce_CharPointer_UTF8.h.

## ◆ operator<=()

bool juce::CharPointer_UTF8::operator<= | ( | CharPointer_UTF8 | other | ) | const
| inlinenoexcept

Definition at line 61 of file juce_CharPointer_UTF8.h.

## ◆ operator=() [1/2]

CharPointer_UTF8 juce::CharPointer_UTF8::operator= | ( | CharPointer_UTF8 | other | ) |
| inlinenoexcept

Definition at line 46 of file juce_CharPointer_UTF8.h.

## ◆ operator=() [2/2]

CharPointer_UTF8 juce::CharPointer_UTF8::operator= | ( | const CharType * | text | ) |
| inlinenoexcept

Definition at line 52 of file juce_CharPointer_UTF8.h.

## ◆ operator==()

bool juce::CharPointer_UTF8::operator== | ( | CharPointer_UTF8 | other | ) | const
| inlinenoexcept

This is a pointer comparison, it doesn't compare the actual text.

Definition at line 59 of file juce_CharPointer_UTF8.h.

## ◆ operator>()

bool juce::CharPointer_UTF8::operator> | ( | CharPointer_UTF8 | other | ) | const
| inlinenoexcept

Definition at line 64 of file juce_CharPointer_UTF8.h.

## ◆ operator>=()

bool juce::CharPointer_UTF8::operator>= | ( | CharPointer_UTF8 | other | ) | const
| inlinenoexcept

Definition at line 63 of file juce_CharPointer_UTF8.h.

## ◆ operator[]()

juce_wchar juce::CharPointer_UTF8::operator[] | ( | int | characterIndex | ) | const
| inlinenoexcept

Returns the character at a given character index from the start of the string.

Definition at line 213 of file juce_CharPointer_UTF8.h.

## ◆ sizeInBytes()

size_t juce::CharPointer_UTF8::sizeInBytes | ( |  | ) | const
| inlinenoexcept

Returns the number of bytes that are used to represent this string. This includes the terminating null character.

Definition at line 275 of file juce_CharPointer_UTF8.h.

## ◆ toLowerCase()

juce_wchar juce::CharPointer_UTF8::toLowerCase | ( |  | ) | const
| inlinenoexcept

Returns a lower-case version of the first character of this string.

Definition at line 467 of file juce_CharPointer_UTF8.h.

## ◆ toUpperCase()

juce_wchar juce::CharPointer_UTF8::toUpperCase | ( |  | ) | const
| inlinenoexcept

Returns an upper-case version of the first character of this string.

Definition at line 465 of file juce_CharPointer_UTF8.h.

## ◆ write()

void juce::CharPointer_UTF8::write | ( | const juce_wchar | charToWrite | ) |
| inlinenoexcept

Writes a unicode character to this string, and advances this pointer to point to the next position.

Definition at line 327 of file juce_CharPointer_UTF8.h.

Referenced by juce::MemoryOutputStream::appendUTF8Char().

## ◆ writeAll() [1/2]

template<typename CharPointer >

void juce::CharPointer_UTF8::writeAll | ( | const CharPointer | src | ) |
| inlinenoexcept

Copies a source string to this pointer, advancing this pointer as it goes.

Definition at line 360 of file juce_CharPointer_UTF8.h.

## ◆ writeAll() [2/2]

void juce::CharPointer_UTF8::writeAll | ( | const CharPointer_UTF8 | src | ) |
| inlinenoexcept

Copies a source string to this pointer, advancing this pointer as it goes.

Definition at line 366 of file juce_CharPointer_UTF8.h.

## ◆ writeNull()

void juce::CharPointer_UTF8::writeNull | ( |  | ) | const
| inlinenoexcept

Writes a null character to this string (leaving the pointer's position unchanged).

Definition at line 353 of file juce_CharPointer_UTF8.h.

## ◆ writeWithCharLimit()

template<typename CharPointer >

void juce::CharPointer_UTF8::writeWithCharLimit | ( | const CharPointer | src,
|  | const int | maxChars )
| inlinenoexcept

Copies a source string to this pointer, advancing this pointer as it goes. The maxChars parameter specifies the maximum number of characters that can be written to the destination buffer before stopping (including the terminating null).

Definition at line 392 of file juce_CharPointer_UTF8.h.

## ◆ writeWithDestByteLimit()

template<typename CharPointer >

size_t juce::CharPointer_UTF8::writeWithDestByteLimit | ( | const CharPointer | src,
|  | const size_t | maxDestBytes )
| inlinenoexcept

Copies a source string to this pointer, advancing this pointer as it goes. The maxDestBytes parameter specifies the maximum number of bytes that can be written to the destination buffer before stopping.

Definition at line 382 of file juce_CharPointer_UTF8.h.

The documentation for this class was generated from the following file:

- juce_CharPointer_UTF8.h